function varargout = view_mobo(varargin)

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @view_mobo_OpeningFcn, ...
                   'gui_OutputFcn',  @view_mobo_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


function view_mobo_OpeningFcn(hObject, eventdata, handles, varargin)

handles.output = hObject;

handles.prefixJpg = uigetdir(pwd,'Set directory of moboJpg ...');

handles.showLabeled = 0;
set(handles.labeled_only,'Value',0);

handles.image_position = get(handles.image_axes,'Position');
set(handles.zoom,'Value',1.0);

com = sprintf('dir /b %s > foosubj',handles.prefixJpg);
dos(com);
handles.subjects = textread('foosubj','%s','whitespace','\n');
set(handles.subject_index,'String',handles.subjects,'Value',1);

com = sprintf('dir /b %s\\%s\\%s > foocam',handles.prefixJpg,handles.subjects{1},'slowWalk');
dos(com);
handles.cameras = textread('foocam','%s','whitespace','\n');
set(handles.camera_index,'String',handles.cameras,'Value',1);

load('data-mobo.mat');
handles.shape = shape;
handles.visibility = visibility;

handles.idx_subj = 1;
handles.idx_cam = 1;
handles.idx_frm = 1;
handles = load_frames(hObject,handles);
handles = load_image(hObject,handles);

guidata(hObject, handles);


% --- Outputs from this function are returned to the command line.
function varargout = view_mobo_OutputFcn(hObject, eventdata, handles)

varargout{1} = handles.output;


function subject_index_CreateFcn(hObject, eventdata, handles)

if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

set(hObject,'String','');


function subject_index_Callback(hObject, eventdata, handles)

idx = get(hObject,'Value');
if idx==handles.idx_subj
  return;
end

handles.idx_subj = idx;
handles.idx_frm = 1;
handles = load_frames(hObject,handles);
handles = load_image(hObject,handles);

guidata(hObject, handles);


function camera_index_CreateFcn(hObject, eventdata, handles)

if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


function camera_index_Callback(hObject, eventdata, handles)

idx = get(hObject,'Value');
if idx==handles.idx_cam
  return;
end

handles.idx_cam = idx;
if handles.showLabeled
  handles.idx_frm = 1;
end
handles = load_frames(hObject,handles);
handles = load_image(hObject,handles);

guidata(hObject, handles);


function next_Callback(hObject, eventdata, handles)

idx = handles.idx_frm+1;
if (idx > handles.n)
  beep;
  return;
end

% Update controls
handles.idx_frm = idx;
handles = load_image(hObject,handles);

guidata(hObject, handles);


function prev_Callback(hObject, eventdata, handles)

idx = handles.idx_frm-1;
if idx < 1
  beep;
  return;
end

% Update controls
handles.idx_frm = idx;
handles = load_image(hObject,handles);

guidata(hObject, handles);


function goto_CreateFcn(hObject, eventdata, handles)

if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


function goto_Callback(hObject, eventdata, handles)

idx = str2double(get(hObject,'String'));
if ((idx < 1) || (idx > handles.nframes))
  beep;
  return;
end
idx = find(handles.l==idx);
if isempty(idx)
  beep;
  return;
end

% Update controls
handles.idx_frm = idx;
handles = load_image(hObject,handles);

guidata(hObject, handles);


function zoom_CreateFcn(hObject, eventdata, handles)

usewhitebg = 1;
if usewhitebg
    set(hObject,'BackgroundColor',[.9 .9 .9]);
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


function zoom_Callback(hObject, eventdata, handles)

zoom = get(hObject,'Value');
origin = handles.image_position(3:4)*(1-zoom)*0.5;
new_position = handles.image_position*zoom + [origin 0 0];
set(handles.image_axes,'Position',new_position);

guidata(hObject, handles);


function labeled_only_Callback(hObject, eventdata, handles)

handles.showLabeled = 1-get(hObject,'Value');

handles.idx_frm = 1;
handles = load_frames(hObject,handles);
handles = load_image(hObject,handles);

guidata(hObject, handles);


%------------------------------------------------------------------------
function [handles] = load_frames(hObject,handles)

handles.path = sprintf('%s\\%s\\%s\\%s\\',handles.prefixJpg, ...
                        handles.subjects{handles.idx_subj}, ...
                        'slowWalk', ...
                        handles.cameras{handles.idx_cam});
com = sprintf('dir /b %s\\*.jpg > fooframe',handles.path);
dos(com);
handles.frames = textread('fooframe','%s','whitespace','\n');
handles.nframes = length(handles.frames);

idx = (handles.idx_subj-1)*100 + 1;
idx = [idx:idx+99];
handles.s = handles.shape{handles.idx_cam}(:,idx);
handles.v = handles.visibility{handles.idx_cam}(:,idx);
handles.l = [1:100];
handles.n = 100;
if handles.showLabeled
  l = find(sum(handles.v,1)>0);
  if length(l) == 0
    disp('Warning: No labeled images found.');
  else
    handles.l = l;
    handles.n = length(handles.l);
  end
end


function [handles] = load_image(hObject,handles)

idx = handles.l(handles.idx_frm);

fn = strcat(handles.path,handles.frames{idx});
Irgb = imread(fn);
if (handles.idx_cam<3)
  Irgb = flipdim(Irgb,2);
end
axes(handles.image_axes);
iptsetpref('ImshowBorder', 'tight');
imshow(Irgb,[]);

plotparts(handles.s(:,idx),handles.v(:,idx),handles.image_axes,0,0);

buf = sprintf('%03d / %03d',idx,handles.nframes);
set(handles.frame_index,'String',buf);
